//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
//@XCb`̓vO
//@@oaOFXCb`(SW_LEFT) 
//@@oaPFEXCb`(SW_RIGHT) 
//@@QL邪AH́uoaOFXCb`(SW_LEFT)v͖B
//
//@kdc
//@@ocTFgœ_Akŏ
//
//@uU[́uTimer 0 OC0Bvo͂ƂȂB
//@@^C}[ȌݒsɎgpłB
//@@H̓uU[Ƃkdco̓sŁA
//@@kdcĂ̂Ł@uU[͎g킸kdcƂĎgpB
//
//@guppX
//@@uTimer 1 OC1Bvo͂ƂȂB
//@@o͒l̃j^[͖̂ ݒlo͂B
//
//	
//@@N@EXCb`Ă
//@@@uݒl̕ύXvAuۑf[^̕\ƑMv̑IB
//@@N@EXCb`ĂȂ
//@@@^CgAo[W\@ɓB
//@@@莞̕\
//@@@@Pʂ
//@@@@@i͐肕r^ƕςr^@ODOP`XDXX܂ł̂PWƂBς͂QÖړ
//@@@@@i̓obe[xƑғԁiXXԂTXTXbRUOOObj
//@@@@@ 0 1 2 3 4 5 6 7 8 9101112131415
//@@@@@@XDXX@`D@XDXX
//@@@@@@@@@@@@QRFTXFTX
//@@@@Qʂ
//@@@@@i݂͌̂lƂl
//@@@@@ 0 1 2 3 4 5 6 7 8 9101112131415
//@@@@@XXXX@XXXXX
//@@@@@@@@@@@@QRFTXFTX
//
//@@@@蒆
//@@@@@PԖ̃JEglijɕۑB
//@@@@@PɃobe[d`FbNČx\B
//
//@@@@PʂƑQʂ̐؂ւ͉EXCb`邲ƂɍsB
//
//@@@ݒl̕ύXI΂ꂽ
//@@@@pXkdco͂̂nm^nee
//@@@@r^ZliXpj̕ύX
//@@@@r^ZliItZbgj̕ύX
//@@@@obe[x`^cl̕ύX
//
//@@@ۑf[^̕\ƑMI΂ꂽ
//@@@@f[^̕\
//@@@@f[^̑M
//
//@EXCb`Ł@ڂ̑Iƍڂ̈ړsKvL̂
//@@ANV͉łȂAɍsB
//@@̗ɉĂԂɂā@Iړ߂B
//@@Ԃ͂PbړƂAPbȏIƂB
//@@l̕ύX̎́@ɂ͂PbԊuŘAā{PB
//
//
//
//
//
//
//  2011/06/02 Taishi
//  2011/08/07 Taishi Ver 1.10 guj^W̕ύXƐݒ@̕ύXA`\oOC
//                           guj^[h폜
//  2011/12/17 Taishi for AT mega168-SI29
//  2012/ 1/20 Taishi for AT mega168-SI22BG
//  2012/ 2/ 5 Taishi for AT mega168 1MHz
//  2012/ 2/22 Taishi Ver 1.21 肕r^UObԂ̈ړςɂ
//                           SI-29BG ̂|r^ZlVOOPORSɕύX
//  2012/ 3/23 Taishi Ver 1.30 SI-29BG ̂|r^ZlPORSXPOɕύX
//                           EEPROM ɕۑf[^𑽂āAIł悤ɂ
//  2012/ 7/ 7 Taishi Ver 1.31 LND712ǉAۑf[^̎ރ`FbNoOC
//*****************************************


#include	<avr/interrupt.h>
#include	<avr/io.h>
#include	<avr/pgmspace.h>
#include	<avr/sleep.h>
#include	<avr/eeprom.h>

#include	"ATmega168_geiger.h"
#include	"const_str.h"
#include	"gei_eeprom.h"
#include	"timer.h"
#include	"utl.h"
#include	"glb_dat.h"
#include	"a_d.h"
#include	"lcd.h"
#include	"uart.h"
#include	"pulse.h"
#include	"port_bit.h"
#include	"settei.h"
#include	"display.h"



//*****************************************
// Main
//*****************************************
int	main(void)
{
	unsigned int	befor_count_minute;							// OJEg
	unsigned char	old_tim_1s_a;								// Ob
	unsigned char	tim_1minute;								// 
	unsigned char	i;
	unsigned char	j;
	unsigned char	uSv_cpm_disp=0;								// 0:uSv+uSv, 1:cph+cpm
	unsigned char	bat_low = 0;
	unsigned char	hour=0;										// vԁij
	unsigned char	minute=0;									// vԁij
	unsigned char	sec=0;										// vԁibj
	unsigned char	gamen_hyouji_req = 0;						// ʕ\vNA
	unsigned char	uc;

	PRR |= ( (1 << PRTWI) | (1 << PRSPI) | (1 << PRUSART0) | (1 << PRTIM0) | (1 << PRTIM1) | (1 << PRTIM2) | (1 << PRADC) );	// TWI, SPI, UART0, Timer0, Timer1, Timer2, ADC ~
	DDRB = ((1 << DDB2) | (1 << DDB3) | (1 << DDB4) | (1 << DDB5));				// PB0,PB1:Input, PB2--5:Output
	DDRC = ((1 << DDC1) | (1 << DDC2) | (1 << DDC3) | (1 << DDC4) | (1 << DDC5));				// PC0:Input, PC1--5:Output
	DDRD = ((1 << DDD1) | (1 << DDD2) | (1 << DDD4) | (1 << DDD5) | (1 << DDD6) | (1 << DDD7));	//PD0,PD3:Input, PD1,PD2,PD4--7:Output
	PORTD |= (1 << PD0);										// PD0 Pullup
	PORTB |= ((1 << PB0) | (1 << PB1));							// PB0,PB1 Pullup

	delay_ms(200);												// 200mS Delay

	read_config();												// ۑݒl̓ǂݏo

#ifdef		HARD_TEST
// ***************** Hard Check **** strat ***********
	// LED Check@kdcPO_ł
	for(i=0;i<10;i++){
		led_on_off(1);							// LED ON
		delay_ms(500);							// 500mS Delay
		led_on_off(0);							// LED OFF
		delay_ms(500);							// 500mS Delay
	}

	// LED Check@kdcT񑬂_ł
	for(i=0;i<5;i++){
		led_on_off(1);							// LED ON
		delay_ms(100);							// 500mS Delay
		led_on_off(0);							// LED OFF
		delay_ms(100);							// 500mS Delay
	}

	// Switch Check@TbԂ̓XCb`͂łkdcnm^nee
	for(i=0;i<250;i++){
		delay_ms(20);							// 20mS Delay
		j = ((~PINB) & SW_RIGHT);				// ]ăXCb`f[^擾
		if(j != 0){								// XCb`
			led_on_off(1);						// LED ON
		}else if(j == 0){						// XCb`
			led_on_off(0);						// LED OFF
		}
	}
	wait_sw_off();								// Q̃XCb`Q@܂ŉiv[v
	led_on_off(0);								// LED OFF

	uart_init();												// UART Initial
	init_lcd();									// Init. LCD
	get_pgm_str(&str_title_1[0]);				// vÖ̕("Geiger Counter")擾
	disp_lcd(0, 0, disp_moji);					// display LCD(16char x 2Line) Up Side
	uart_tx_str_crlf("");						// UART TxD String + CR + LF
	uart_tx_str_crlf((char *)&disp_moji[0]);	// UART TxD String + CR + LF


	Timer2_init();								// Timer2 Initial
	ad0_init();									// A/D 0 Initial
	count_init();								// Count Initial
	tim_1s_a = 10;								// PbPʃ^C}[POɃZbg
	i = tim_1s_a;
	sei();										// 荞݉
	for(;;){
		led_on_off(1);							// LED ON
		delay_ms(200);							// 100mS Delay
		led_on_off(0);							// LED OFF
		delay_ms(200);							// 100mS Delay
		if(i != tim_1s_a){						// bω
			i = tim_1s_a;
			wtod_02u((char *)&disp_moji[0],i);
			disp_lcd(0, 1, disp_moji);			// display LCD(16char x 2Line) Down Side
			uart_tx_str_crlf((char *)&disp_moji[0]);	// UART TxD String + CR + LF
			bat_ad = ad0_get_data();				//  obt@ɓĂf[^𕽋ςĎ擾
			wtod_05u((char *)&disp_moji[0], bat_ad);
			disp_lcd(4, 1, disp_moji);			// display LCD(16char x 2Line) Down Side
			uart_tx_str_crlf((char *)&disp_moji[0]);	// UART TxD String + CR + LF
			if(i == 0){						// PObo߂
				break;
			}
		}
	}

	Timer1_init();								// Timer1 Initial
	HV_on();									// High Volt ON

	for(;;){
		wtod_05u((char *)&disp_moji[0], count_minute);
		disp_lcd(10, 1, disp_moji);				// display LCD(16char x 2Line) Down Side
		led_on_off(1);							// LED ON
		delay_ms(100);							// 100mS Delay
		led_on_off(0);							// LED OFF
		delay_ms(100);							// 100mS Delay
	}

// ***************** Hard Check **** end ***********
#endif		//HARD_TEST

	// LED
	led_on_off(1);												// LED ON
	delay_ms(500);												// 500mS Delay
	led_on_off(0);												// LED OFF

	init_lcd();													// Init. LCD

	i = 0;
	j = ((~PINB) & SW_RIGHT);									// ]ăXCb`f[^擾
	if(j != 0){													// XCb`Ă鎞
		delay_ms(20);											// 20mS Delay
		j = ((~PINB) & SW_RIGHT);								// ]ăXCb`f[^擾
		if(j != 0){												// QxƂĂ鎞
			i = 1;												// XCb`ĂƂ
		}
	}

	disp_title(i);												// ^Cg\
	Timer2_init();												// Timer2 Initial
	if(i == 1){													// XCb`Ă
		select_config_savedata();								// ݒlύX or ۑf[^\AM̑I s
	}


	Timer1_init();												// Timer1 Initial
	HV_on();													// High Volt ON

	get_pgm_str(&str_hv_wait[0]);								// vÖ̕("HV Wait")擾
	disp_lcd( 0,0,disp_moji);									// \
	if(led_on == 1){
		get_pgm_str(&str_led_enable[0]);						// vÖ̕("LED Ena")擾
	}else{
		get_pgm_str(&str_led_disable[0]);						// vÖ̕("LED Dis")擾
	}
	disp_lcd( 0,1,disp_moji);									// \


	get_pgm_str(&str_ten8[0]);									// vÖ̕("........")擾
	for(i=0;i<8;i++){
		disp_lcd( 7+i,0,&disp_moji[7]);							// "." \
		delay_ms(1000);											// 1S Delay
	}

	befor_count_minute = 0xffff;
	old_count_minute = 0xffff;
	old_count_hour = 0xffff;
	old_tim_1s_a = 0xff;
	tim_1minute = 60;
	ave_data_pos = 0;											// xۑf[^̈ʒu
	for(i=0;i<0x40;i++){
		ave_data[i] = 0xffff;									// P̃f[^US
		sec_data[i] = 0xffff;									// Pb̃f[^US
	}

	count_init();												// Count Initial
	get_pgm_str(&str_space10[0]);								// vÖ̕("          ")擾
	disp_lcd(0,1,&disp_moji[2]);								// \

	set_sleep_mode(SLEEP_MODE_IDLE);							// X[vFACh[h


	sei();														// 荞݉
	ad0_init();													// A/D 0 Initial
	tim_10ms_ad0 = 200;											// `^cOpPOrPʃ^C}[Zbg@Qb
	gamen_hyouji_req = 3;										// ʕ\v-->L
	for(;;){
		//@XCb`
//		gamen_hyouji_req = 0;									// ʕ\vNA
		uc = get_action_sw();									// XCb`Ԃ
		uc &= 0x0f;												// EXCb`ɂ
		if(uc != 0){											// ANVL鎞
			if(uc == SWR_OFF_SHORT){							// Zꂽ
				uSv_cpm_disp ^= 0x01;							// 0:ru^\ 1:A\
				gamen_hyouji_req = 3;							// ʕ\v-->L
			}else if(uc == SWR_OFF_LONG){						// ꂽ
				led_on ^= 0x01;									// kdcgp̕ύX
			}
		}
		if(befor_count_minute != count_minute){					// JE^lω
			gamen_hyouji_req |= 1;								// ʕ\v-->L
			befor_count_minute = count_minute;
		}

		if(old_tim_1s_a != tim_1s_a){							// bω
			old_tim_1s_a = tim_1s_a;
			old_count_sec = count_sec;							// OPbԖ̃JEg
			count_sec = 0;
			sec_data[sec] = old_count_sec;						// Pb̃f[^𕽋ϒlpɕۑ
			sec++;												// vԁibj
			gamen_hyouji_req |= 1;								// ʕ\v-->L
			if(sec == 60){
				sec = 0;
				minute++;										// 
				if(minute == 60){
					minute = 0;
					hour++;										// 
					if(hour == 100){
						hour = 0;
					}
				}
			}
			if(tim_1s_a == 0){										// UObo߂
				tim_1s_a = 60;
				old_tim_1s_a = tim_1s_a;
				tim_1minute--;										// 
				// JE^\
				old_count_minute = count_minute;					// OPԖ̃JEg
				count_minute = 0;
				if((eep_save_mode == 1)||(eep_save_mode == 3)){		// [cpm one cycle] or [cpm endless] ̎
					save_data_to_EEP(old_count_minute);				// f[^̕ۑ
				}
				if(tim_1minute == 0){								// UOo߂
					tim_1minute = 60;
					old_count_hour = count_hour;					// OPԖ̃JEg
					if((eep_save_mode == 2)||(eep_save_mode == 4)){	// [cph one cycle] or [cph endless] ̎
						save_data_to_EEP(old_count_hour);			// f[^̕ۑ
					}
					count_hour = 0;
				}
				if(bat_low == 0){									// dr܂vȎ
					ad0_init();										// A/D 0 Initial
					tim_10ms_ad0 = 200;								// `^cOpPOrPʃ^C}[Zbg@Qb
				}

				ave_data[ave_data_pos] = old_count_minute;			// P̃f[^𕽋ϒlpɕۑ
				ave_data_pos++;										// xۑf[^̈ʒuɂ
				ave_data_pos &= 0x3f;
				gamen_hyouji_req |= 2;								// PԒl̉ʕ\v-->L
			}
		}

		// LED
		if(led_on == 1){										// kdcgp̎
			if(tim_10ms_led != 0){
				led_on_off(1);									// LED ON
			}else{
				led_on_off(0);									// LED OFF
			}
		}

		// Battery Check
		if(ad0_active == 1){									// `^cOL
			if(tim_10ms_ad0 == 0){								// `^cÕf[^\ɏW܂
				bat_ad = ad0_get_data();						// obt@ɓĂf[^𕽋ςĎ擾
				ad0_close();									// A/D 0 Close
				if(bat_ad < BAT_AD_LOW){						// Œd艺
					bat_low = 1;								// obe[knvnm
					tim_10ms_bat = 0;							// obe_Ń^C}[Zbg
				}
				disp_battery();									// obel\
			}
		}

		// obe[A[\
		if(bat_low != 0){										// obe[knv̎
			if((bat_low == 1)&&(tim_10ms_bat == 0)){			// obe[knvŎԂo߂
				get_pgm_str(&str_bat_loss[0]);					// drȂiGj擾
				disp_lcd( 0, 1, &disp_moji[0]);					// display LCD(16char x 2Line) Down Side
				tim_10ms_bat = 50;
				bat_low = 2;
			}else if((bat_low == 2)&&(tim_10ms_bat == 0)){		// obe[knvŎԂo߂
				get_pgm_str(&str_space10[0]);					// "  "擾
				disp_lcd( 0, 1, &disp_moji[8]);					// display LCD(16char x 2Line) Down Side
				tim_10ms_bat = 50;
				bat_low = 1;
			}
		}

		if(gamen_hyouji_req != 0){								// ʕ\vL鎞
			gamen_hyouji_req &= ~1;
			if(uSv_cpm_disp == 0){								// ru^\̎
				disp_average_60sec(1, 0, sec);					// UObԂ̈ړ
				if(gamen_hyouji_req != 0){						// PԒl̉ʕ\vL鎞
					disp_average_few_min(7, 0);					// rZ\i\ԕςr^j
				}
				get_pgm_str(&str_space10[0]);					// vÖ̕("          ")擾
				disp_lcd(0,0,&disp_moji[9]);					// \
				disp_lcd(6,0,&disp_moji[9]);					// \
			}else{												// A\̎
				wtod_5u((char *)disp_moji,count_minute);			// PԖ
				disp_lcd(0, 0, &disp_moji[1]);					// display LCD(16char x 2Line) Up Side
				wtod_5u((char *)disp_moji,count_hour);			// PԖ
				disp_lcd(8, 0, &disp_moji[0]);					// display LCD(16char x 2Line) Up Side
				get_pgm_str(&str_cpm[0]);						// "cpm"擾
				disp_lcd( 4, 0, &disp_moji[0]);					// display LCD(16char x 2Line) Up Side
				get_pgm_str(&str_cph[0]);						// "cph"擾
				disp_lcd(13, 0, &disp_moji[0]);					// display LCD(16char x 2Line) Up Side
			}

// ---- `FbNp -----
//			disp_battery();										// obe`^cl\
// ---------------------

			wtod_02u((char *)(disp_moji), sec);					// vԁibj
			disp_lcd(13, 1, &disp_moji[0]);						// display LCD(16char x 2Line) Down Side
			wtod_02u((char *)(disp_moji), minute);				// vԁij
			disp_lcd(10, 1, &disp_moji[0]);						// display LCD(16char x 2Line) Down Side
			wtod_2u((char *)(disp_moji), hour);					// vԁij
			disp_lcd( 7, 1, &disp_moji[0]);						// display LCD(16char x 2Line) Down Side
			get_pgm_str(&str_colon[0]);							// ":"擾
			disp_lcd( 9, 1, &disp_moji[0]);						// display LCD(16char x 2Line) Down Side
			disp_lcd(12, 1, &disp_moji[0]);						// display LCD(16char x 2Line) Down Side
		}
		if(led_on == 1){										// kdcgp̎
			get_pgm_str(&str_lamp[0]);							// kdciGj
			disp_lcd(15, 1, &disp_moji[0]);						// display LCD(16char x 2Line) Down Side
		}else{
			get_pgm_str(&str_space10[0]);						// "  "
			disp_lcd(15, 1, &disp_moji[9]);						// display LCD(16char x 2Line) Down Side
		}
		sleep_mode();											// X[vڍs
		gamen_hyouji_req = 0;
	}
}
