//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:timer.h
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//*****************************************

#define		COUNT_1MS		125						// 1mS  ^C}[͂1MHz/64 = 125kHz(8uS)̎
#define		KHz_7R8		16							// 7,8kHz
#define		KHz_5		25							// 5kHz
#define		KHz_4		31							// 4kHz
#define		KHz_2		62							// 2kHz
#define		KHz_1		125							// 1kHz
#define		KHz_0R49	255							// 490Hz

extern	unsigned char	tim_1s_a;
extern	unsigned int	hv_out;

extern	void	delay_16us(unsigned char t);
extern	void	delay_ms(int tm);
extern	void	Timer1_init(void);
extern	void	HV_on(void);
extern	void	HV_off(void);
extern	void	set_Timer1_ontime(void);
extern	void	Timer0_init(void);
extern	void	Timer2_init(void);
