//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:uart.h
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//*****************************************


#define	BIT_RATE4800		4800								// rbg|g:4800
#define	BIT_RATE9600		9600								// rbg|g:9600


// t`qs̐ݒl

// aor
#define	BPS_4800		(unsigned int)(((long)CLOCK/(long)8/(long)BIT_RATE4800) - 1)	// taqqO̒l(4800)
#define	BPS_9600		(unsigned int)(((long)CLOCK/(long)8/(long)BIT_RATE9600) - 1)	// taqqO̒l(9600)

// peB
#define	V_PARITY_NON	((0 << UPM01) | (0 << UPM00))									// peB
#define	V_PARITY_EVN	((1 << UPM01) | (0 << UPM00))									// peB
#define	V_PARITY_ODD	((1 << UPM01) | (1 << UPM00))									// peB

// f[^
#define	V_DATA_8		((1 << UCSZ00) | (1 << UCSZ01))									// Wrbgf[^
#define	V_DATA_7		((0 << UCSZ00) | (1 << UCSZ01))									// Vrbgf[^

// tbrqO`̒l
#define	V_UCSR0A		(1 << U2X0)														// tbrqO`̒l: {

// tbrqOa̒l
#define	V_UCSR0B		(1 << TXEN0)													// tbrqOa̒l: M

extern	void	uart_init(void);
extern	void	uart_close(void);
extern	void	uart_tx_one(unsigned char uc);
extern	void	uart_tx_str(char *str);
extern	void	uart_tx_str_crlf(char *str);

