//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:const_str.h
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//*****************************************

extern	unsigned char	str_title_1[] PROGMEM;			// ^Cg|P
extern	unsigned char	str_title_2[] PROGMEM;			// ^Cg|Q
extern	unsigned char	str_title_3[] PROGMEM;			// ^Cg|R
extern	unsigned char	str_date[] PROGMEM;				// 쐬@N
extern	unsigned char	str_time[] PROGMEM;				// 쐬@
extern	unsigned char	str_cpm[] PROGMEM;				// "cpm"
extern	unsigned char	str_cph[] PROGMEM;				// "cph"
extern	unsigned char	str_save_data[] PROGMEM;		// "No  cph  uSv/h"
extern	unsigned char	str_5minus[] PROGMEM;			// "-----"
extern	unsigned char	str_no_data[] PROGMEM;			// "Non Data !!"
extern	unsigned char	str_hv_wait[] PROGMEM;			// "HV Wait"
extern	unsigned char	str_led_enable[] PROGMEM;		// "LED Enable"
extern	unsigned char	str_led_disable[] PROGMEM;		// "LED Disable"
extern	unsigned char	str_space10[] PROGMEM;			// "          "
extern	unsigned char	str_adj[] PROGMEM;				// "Adj"
extern	unsigned char	str_save_exit[] PROGMEM;		// "Save&Exit
extern	unsigned char	str_save_next[] PROGMEM;		// "Save&Next
extern	unsigned char	str_ten8[] PROGMEM;				// "."

extern	unsigned char	str_hv_out[] PROGMEM;			// "HV-Out"
extern	unsigned char	str_cpm_to_uSv[] PROGMEM;		// "com->uSv"
extern	unsigned char	str_per_h[] PROGMEM;			// "/h"
extern	unsigned char	str_uSv[] PROGMEM;				// "uSv"
extern	unsigned char	str_span[] PROGMEM;				// "Span"
extern	unsigned char	str_offset[] PROGMEM;			// "Ofset"

extern	unsigned char	str_cr_lf[] PROGMEM;			// CR+LF
extern	unsigned char	str_5asta[] PROGMEM;			// "*****"
extern	unsigned char	str_average[] PROGMEM;			// "Ave. "

extern	unsigned char	str_zero[] PROGMEM;				// "0"
extern	unsigned char	str_dive[] PROGMEM;				// "/"
extern	unsigned char	str_minus[] PROGMEM;			// "-"
extern	unsigned char	str_asta[] PROGMEM;				// "*"
extern	unsigned char	str_plus[] PROGMEM;				// "+"
extern	unsigned char	str_colon[] PROGMEM;			// ":"
extern	unsigned char	str_sharp[] PROGMEM;			// "#"
extern	unsigned char	str_comma[] PROGMEM;			// ","
extern	unsigned char	str_volt[] PROGMEM;				// "V"

extern	unsigned char	str_bat_loss[] PROGMEM;			// drȂiGj
extern	unsigned char	str_bat_low[] PROGMEM;			// driGj
extern	unsigned char	str_bat_mid[] PROGMEM;			// driGj
extern	unsigned char	str_bat_high[] PROGMEM;			// driGj
extern	unsigned char	str_proces[] PROGMEM;			// "Proces Select"
extern	unsigned char	str_disp[] PROGMEM;				// "Disp"
extern	unsigned char	str_trans[] PROGMEM;			// "Trans"
extern	unsigned char	str_erase[] PROGMEM;			// "Erase"
extern	unsigned char	str_done[] PROGMEM;				// "Done"
extern	unsigned char	str_data[] PROGMEM;				// "Data"
extern	unsigned char	str_led[] PROGMEM;				// "LED"
extern	unsigned char	str_config[] PROGMEM;			// "Config"
extern	unsigned char	str_savedata[] PROGMEM;			// "SaveData"
extern	unsigned char	str_enable[] PROGMEM;			// "Enable"
extern	unsigned char	str_disable[] PROGMEM;			// "Disable"
extern	unsigned char	str_transmit[] PROGMEM;			// "Transmit"
extern	unsigned char	str_makedate[] PROGMEM;			// "Make Date: "
extern	unsigned char	str_display[] PROGMEM;			// "Display"
extern	unsigned char	str_lamp[] PROGMEM;				// kdciGj
extern	unsigned char	str_eep_save[] PROGMEM;			// "EEP Save"
extern	unsigned char	str_cpm_one_cycl[] PROGMEM;		// "Cpm One Cycle"
extern	unsigned char	str_cph_one_cycl[] PROGMEM;		// "Cph One Cycle"
extern	unsigned char	str_cpm_endless[] PROGMEM;		// "Cpm Endless"
extern	unsigned char	str_cph_endless[] PROGMEM;		// "Cph Endless"
extern	unsigned char	str_off[] PROGMEM;				// "OFF"
extern	unsigned char	str_mode[] PROGMEM;				// "Mode"
extern	unsigned char	str_change[] PROGMEM;			// "Change"
extern	unsigned char	str_cancel[] PROGMEM;			// "Cancel"
extern	unsigned char	str_eep[] PROGMEM;				// "EEP"

extern	unsigned char	disp_moji[17];

extern	void	get_pgm_str(unsigned char *puc);
