//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:gei_eeprom.h
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//  2012/ 7/ 7 Taishi Ver 1.30(LND712)
//*****************************************

#define	N_of_SAVE_DATA		128										// ddoqnlɕۑf[^

#ifdef		SI_22BG													// SI-22BG
 #define	Cpm_uSv_SPN_DEFAULT	500									// SI-22BG |r^Zl𐳊mɂׂ̕␳lXp̃ftHgl(1uSv/h cpml 500 --> 50.0)
#else		// SI_22BG
 #ifdef 	SI_29BG
  #define	Cpm_uSv_SPN_DEFAULT	910									// SI-29BG |r^Zl𐳊mɂׂ̕␳lXp̃ftHgl(1uSv/h cpml 910 --> 91.0)
 #else		// SI_29BG
  #ifdef	LND712
   #define	Cpm_uSv_SPN_DEFAULT	1230								// |r^Zl𐳊mɂׂ̕␳lXp̃ftHgl(1uSv/h cpml 1230 --> 123.0)
  #else		//LND712
   #define	Cpm_uSv_SPN_DEFAULT	1100								// |r^Zl𐳊mɂׂ̕␳lXp̃ftHgl(1uSv/h cpml 1100 --> 110.0)
  #endif	// LND712
 #endif		// SI_29BG
#endif		// SI_22BG

#define	Cpm_uSv_SPN_MAX		9999									// |r^Zl𐳊mɂׂ̕␳lXp̍őlA͂XXXɂ鎖
#define	Cpm_uSv_SPN_MIN		1										// |r^Zl𐳊mɂׂ̕␳lXp̍ŏl
#define	Cpm_uSv_OFS_DEFAULT	0										// |r^Zl𐳊mɂׂ̕␳lItZbg̃ftHgl(uSv/h l 1 --> 0.01uSv/h)
#define	Cpm_uSv_OFS_MAX		99										// |r^Zl𐳊mɂׂ̕␳lItZbg̍őlA͂Xɂ鎖
#define	LED_ON_DEFAULT		1										// kdc@nm^neẽftHgl(0:OFF, 1:ON)
#define	EEP_SAVE_DEFAULT	1										// ddoqnlۑ[h̃ftHgli1:cpm One Cycle, 2:cph One cycle, 3:cpm Endless, 4:cph Endlessj

#ifdef	SI_22BG														// SI-22BG
 #define	HV_OUT_DEFAULT		 75									// guo͒l̃ftHgl(1uS * 75 = 75uS)
 #define	HV_OUT_MAX			 99									// guo͒l̍ől(1uS * 99 = 99uS)A͂XXɂ鎖
 #define	HV_OUT_MIN			 40									// guo͒l̍ŏl(1uS * 50 = 50uS)
#else		// SI_22BG
 #ifdef 	SI_29BG													// SI-29BG
  #define	HV_OUT_DEFAULT		 80									// guo͒l̃ftHgl(1uS * 75 = 75uS)
  #define	HV_OUT_MAX			 99									// guo͒l̍ől(1uS * 99 = 99uS)A͂XXɂ鎖
  #define	HV_OUT_MIN			 40									// guo͒l̍ŏl(1uS * 50 = 50uS)
 #else		// SI_29BG
  #ifdef 	LND712													// LND712
   #define	HV_OUT_DEFAULT		117									// guo͒l̃ftHgl(1uS * 100 = 100uS)
   #define	HV_OUT_MAX			199									// guo͒l̍ől(1uS * 199 = 199uS)A͂XXɂ鎖
   #define	HV_OUT_MIN			 50									// guo͒l̍ŏl(1uS * 50 = 50uS)

  #else		// LND712												// ̑
   #define	HV_OUT_DEFAULT		 75									// guo͒l̃ftHgl(1uS * 75 = 75uS)
   #define	HV_OUT_MAX			 99									// guo͒l̍ől(1uS * 99 = 99uS)A͂XXɂ鎖
   #define	HV_OUT_MIN			 50									// guo͒l̍ŏl(1uS * 50 = 50uS)
  #endif	// LND712
 #endif		// SI_29BG
#endif		// SI_22BG



extern	void	save_led_on_off(void);
extern	void	save_eep_save_mode(void);
extern	void	save_usvh_spn(void);
extern	void	save_usvh_ofs(void);
extern	void	save_hv_out(void);
extern	void	read_config(void);
extern	void	delete_save_data_on_EEP(void);
extern	unsigned char	read_save_data_from_EEP(void);
extern	void	save_data_to_EEP(unsigned int ui);
