//*****************************************
// AVR Geiger Counter mega168 Program
// CPU Clock:1MHz
//   iq[Yf[^@WāAOIV[^(8MHz)ɂj
// KCK[JE^[vO
//
// File Name:port_bit.h
//
//  2011/12/17 Taishi New
//  2012/ 3/23 Taishi Ver 1.30
//*****************************************

#define			SW_LEFT		(1 << PINB0)		// XCb`ij
#define			SW_RIGHT	(1 << PINB1)		// EXCb`

// EXCb`̑ԁiSrbgj
#define			SWR_ON				0x01		// EXCb`ꂽB
#define			SWR_OFF_SHORT		0x02		// EXCb`ꂽBĂԂ͒Z
#define			SWR_OFF_LONG		0x03		// EXCb`ꂽBĂԂ͒
#define			SWR_ON_CONTINUE		0x04		// EXCb`ꑱĂBi莞ԊԊuł̒lxoj
// XCb`̑ԁiSrbgj
#define			SWL_ON				0x10		// XCb`ꂽB
#define			SWL_OFF_SHORT		0x20		// XCb`ꂽBĂԂ͒Z
#define			SWL_OFF_LONG		0x30		// XCb`ꂽBĂԂ͒
#define			SWL_ON_CONTINUE		0x40		// XCb`ꑱĂBi莞ԊԊuł̒lxoj

extern	unsigned char	sw[4];					// SW[1] Ɍ݂̏ԁAĂ镨'1'̏ԁA SW[2] ɉꂽuԂ'1'̏ԁA SW[3] ɗꂽuԂ'1'̏

extern	void	led_on_off(unsigned char on_off);
extern	void	get_sw(void);
extern	void	wait_key_off(void);
extern	void	wait_sw_off(void);
extern	unsigned char	get_action_sw(void);
